# FIXME: Use udev sooner or later...

%define     nvidialibdir      %{_libdir}/nvidia
%define     nvidialibdir32bit %{_prefix}/lib/nvidia
%define     nvversion 173.14.16

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary: 	Nvidia Display Driver and OpenGL libraries
Name: 		xorg-x11-drv-nvidia-legacy173xx
Version: 	1.0.%{nvversion}
Release: 	1
Group: 		System/Configuration/Hardware
License: 	Distributable
URL:        	http://www.nvidia.com/
Source0:    	NVIDIA-Linux-x86-%{nvversion}-pkg1.run
Source1:    	NVIDIA-Linux-x86_64-%{nvversion}-pkg2.run
Source202:    	nvidia-glx.sh
Source203:    	nvidia-glx.csh
Source204:    	nvidia-settings.desktop
#Source11:   	nvidia-README.Fedora
Source212:   	nvidia-glx.opts

Source220:	51-nvidia.nodes

Provides:   	nvidia-kmod-common = %{version}

# Require for rpm lzma compression transition
Requires:        rpm >= 4.4.2.3-1

Conflicts:      xorg-x11-drv-nvidia
Conflicts:  	xorg-x11-drv-nvidia-legacy
Conflicts:      xorg-x11-drv-nvidia-legacy96xx
BuildConflicts:	xorg-x11-drv-fglrx

#Requires:   	kmod-nvidia >= %{version}
#Requires(post):  kmod-nvidia >= %{version}
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  i686
#Automatically resolved build dependencies
BuildRequires: atk-devel
BuildRequires: bash
BuildRequires: glibc-devel
BuildRequires: glib-devel
BuildRequires: gtk2+-devel
BuildRequires: libX11-devel
BuildRequires: libXext-devel
BuildRequires: mesa-libGL-devel
BuildRequires: pango-devel
BuildRequires: xorg-x11-server-Xorg
BuildRequires: zlib-devel


%description
This package provides Nvidia hardware accelerated OpenGL support
for Nvidia chipsets from Geforce2, Quadro4 or newer.

%package devel
Summary:    Nvidia OpenGL Headers
Group:      Development/Libraries
Requires:   %{name} = %{version}-%{release}

%description devel
This package provides the Nvidia OpenGL headers and libraries required
for development.

%postun -p /sbin/ldconfig

%post -p /sbin/ldconfig

%prep
%setup -q -c -T
sh %{SOURCE0} --extract-only --target nvidiapkg-x86
sh %{SOURCE1} --extract-only --target nvidiapkg-x64
#tar -cvjf nvidia-glx-kmod-data-1.0.8178.tar.bz2 nvidiapkg-*/LICENSE nvidiapkg-*/usr/src/
%ifarch %{ix86}
ln -s nvidiapkg-x86 nvidiapkg
%else
ln -s nvidiapkg-x64 nvidiapkg
%endif
mv nvidiapkg/LICENSE nvidiapkg/usr/share/doc/
# More docs
find nvidiapkg/usr/share/doc/ -type f | xargs chmod 0644


%install
rm -rf $RPM_BUILD_ROOT

set +x
for file in $(cd nvidiapkg &> /dev/null; find . -type f | grep -v -e 'makeself.sh$' -e 'mkprecompiled$' -e 'tls_test$' -e 'tls_test_dso.so$' -e 'nvidia-settings.desktop$' -e '^./Makefile'  -e '^./nvidia-installer' -e '^./pkg-history.txt' -e '^./.manifest' -e '/usr/share/doc/' -e 'libGL.la$' -e 'drivers/nvidia_drv.o$' -e 'nvidia-installer.1.gz$' -e '^./usr/src/')
do
  if [[ ! "/${file##./usr/lib/}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir}/${file##./usr/lib/}
  elif [[ ! "/${file##./usr/X11R6/lib/modules/extensions}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/extensions/nvidia/${file##./usr/X11R6/lib/modules/extensions}
  elif [[ ! "/${file##./usr/X11R6/lib/modules}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_libdir}/xorg/modules/${file##./usr/X11R6/lib/modules}
  elif [[ ! "/${file##./usr/X11R6/lib/}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir}/${file##./usr/X11R6/lib/}
  elif [[ ! "/${file##./usr/include/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_includedir}/nvidia/${file##./usr/include/}
  elif [[ ! "/${file##./usr/bin/}" = "/${file}" ]]
  then
    if [[ ! "/${file##./usr/bin/nvidia-xconfig}" = "/${file}" ]]
    then
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/usr/sbin/${file##./usr/bin/}
    elif [[ ! "/${file##./usr/bin/nvidia-bug-report.sh}" = "/${file}" ]]
    then
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/usr/bin/${file##./usr/bin/}
    else
      install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/${file}
    fi
  elif [[ ! "/${file##./usr/lib32}" = "/${file}" ]]
  then
    install -D -p -m 0755 nvidiapkg/${file} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/${file##./usr/lib32/}
  elif [[ ! "/${file##./usr/share/man/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_mandir}/${file##./usr/share/man/}
    gunzip $RPM_BUILD_ROOT/%{_mandir}/${file##./usr/share/man/}
  elif [[ ! "/${file##./usr/share/pixmaps/}" = "/${file}" ]]
  then
    install -D -p -m 0644 nvidiapkg/${file} $RPM_BUILD_ROOT/%{_datadir}/pixmaps/${file##./usr/share/pixmaps/}
  else
    echo ${file} found -- don\'t know how to handle
    exit 1
  fi
done
set -x

# Change perms on static libs. Can't fathom how to do it nicely above.
find $RPM_BUILD_ROOT/%{nvidialibdir} -type f -name "*.a" -exec chmod 0644 '{}' \;

# Fixme: should we do this directly in above for-loop? Yes, we should! No, please don't!
ln -s libGLcore.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libGLcore.so
ln -s libGLcore.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libGLcore.so.1
ln -s libGL.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libGL.so
ln -s libGL.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libGL.so.1
ln -s libnvidia-tls.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libnvidia-tls.so.1
ln -s libnvidia-tls.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/tls/libnvidia-tls.so.1
ln -s libnvidia-cfg.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libnvidia-cfg.so.1
ln -s libXvMCNVIDIA.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libXvMCNVIDIA.so
ln -s libXvMCNVIDIA.so.%{nvversion} $RPM_BUILD_ROOT%{nvidialibdir}/libXvMCNVIDIA_dynamic.so.1

ln -s libglx.so.%{nvversion} $RPM_BUILD_ROOT%{_libdir}/xorg/modules/extensions/nvidia/libglx.so

#ln -s libnvidia-wfb.so.%{nvversion} $RPM_BUILD_ROOT%{_libdir}/xorg/modules/libwfb.so


# 32-bit libs on x86_64
%ifarch x86_64
ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGLcore.so
ln -s libGLcore.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGLcore.so.1
ln -s libGL.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libGL.so.1 
ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libnvidia-tls.so.1
ln -s libnvidia-tls.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/tls/libnvidia-tls.so.1
ln -s libnvidia-cfg.so.%{version} $RPM_BUILD_ROOT/%{nvidialibdir32bit}/libnvidia-cfg.so.1
%endif # x86_64

# profile.d files
install -D -p -m 0755 %{SOURCE202} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/nvidia-glx.sh
install -D -p -m 0755 %{SOURCE203} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/nvidia-glx.csh

# modprobe.d file
install -D -p -m 0644 %{SOURCE212} $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/nvidia-glx

# ld.so.conf.d file
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/
echo "%{nvidialibdir}" > $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
%ifarch x86_64
echo "%{nvidialibdir32bit}" >> $RPM_BUILD_ROOT%{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
%endif

# DRI device nodes
install -D -p -m 0644 %{SOURCE220} $RPM_BUILD_ROOT%{_sysconfdir}/udev/makedev.d/51-nvidia.nodes

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc nvidiapkg/usr/share/doc/*
%dir %{nvidialibdir}
%dir %{nvidialibdir}/tls
%dir %{_libdir}/xorg/modules/extensions/nvidia
#%{_initrddir}/nvidia-glx
%{nvidialibdir}/*.so.*
%{nvidialibdir}/tls/*.so.*
%{_sysconfdir}/profile.d/nvidia*
%{_libdir}/xorg/modules/drivers/nvidia_drv.so
%{_libdir}/xorg/modules/extensions/nvidia/*
%{_libdir}/xorg/modules/libnvidia-wfb.so*
#%{_libdir}/xorg/modules/libwfb.so
%{_bindir}/*
%{_sbindir}/*
#%{_datadir}/applications/*nvidia-settings.desktop
%{_datadir}/pixmaps/*.png
%config %{_sysconfdir}/ld.so.conf.d/nvidia-glx.conf
%config %{_sysconfdir}/modprobe.d/nvidia-glx
%{_mandir}/man[1-9]/nvidia*.*
%{_sysconfdir}/udev/makedev.d/51-nvidia.nodes

%ifarch x86_64
%files libs-32bit
%dir %{nvidialibdir32bit}
%dir %{nvidialibdir32bit}/tls
%{nvidialibdir32bit}/*.so.*
%{nvidialibdir32bit}/tls/*.so.*
%endif  #x86_64


%files devel
%defattr(-,root,root,-)
%dir %{_includedir}/nvidia
%dir %{_includedir}/nvidia/GL
%{_includedir}/nvidia/GL/*.h
%{_includedir}/nvidia/cuda/cuda.h
%{_includedir}/nvidia/cuda/cudaGL.h
%{nvidialibdir}/libXvMCNVIDIA.a
%{nvidialibdir}/*.so
%ifarch x86_64
%{nvidialibdir32bit}/*.so
%endif #x86_64


%changelog
* Fri Jan 30 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.16-1
- version update
* Sat Dec 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.15-1
- version update
* Tue Dec 23 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.12-1
- initial CCux package release
- based on xorg-x11-drv-nvidia package
